* Test file for testing op-codes
* Written and constantly being updated by Jason Buttron (1/27/98)

VARIABLE        EQU     $C000
VAR2            EQU     $FF
COUNT           EQU     $E000

		ORG 
		LDS  #$1FF              ; Load stack pointer
		LDAA #0                 ; Initialize ACCA
		LDAB #0                 ; Initialize ACCB
		LDY  #0000
		LDX  #0000
		STAB $1004              ; Initialize PORTB

LOOP:     	INCB      
* Allow a total of 8 subroutines to be called

		XGDY
		BEQ     JSUB1
		INCB
		XGDX
		BEQ     JSUB2
		JMP	LOOP
**************************** Done ***********************
		CMPA    #3
		BEQ     JSUB3
		CMPA    #4
		BEQ     JSUB4
		CMPA    #5
		BEQ     JSUB5
		CMPA    #6
		BEQ     JSUB6
		CMPA    #7
		BEQ     JSUB7
		CMPA    #8
		BEQ     JSUB8
		
		BRA     END            ; Just loop if no subroutine
					; is selected
JSUB1:          JSR     SUB1                
		BRA     END
JSUB2:          JSR     SUB2
		BRA     END
JSUB3:          JSR     SUB3
		BRA     END
JSUB4:          JSR     SUB4
		BRA     END
JSUB5:          JSR     SUB5
		BRA     END
JSUB6:          JSR     SUB6
		BRA     END
JSUB7:          JSR     SUB7
		BRA     END
JSUB8:          JSR     SUB8

END:            BRA     LOOP


*       XGDY
SUB1:           PSHA          
		INY
		PULA
		RTS


*       XGDX
SUB2:           PSHA
		INX
		PULA
		RTS
*************************************** Done **********
*       IND, Y
SUB3:           PSHA
		LDAB COUNT
		INCB
		STAB COUNT
		STAB VARIABLE
		LDY #VARIABLE
		BSET 0,Y %10101010
		LDAB VARIABLE
		STAB $1003
		PULA
		RTS

*       (IND,X)
SUB4:           PSHA
		LDAA VARIABLE
		CMPA #0
		BNE SHIFT4
		LDAA #$80
		STAA VARIABLE
SHIFT4:         LDX #VARIABLE
		ASR 0,X
		LDAA VARIABLE
		STAA $1003
		PULA
		RTS

*       (IND,Y)
SUB5:           PSHA
		LDAA VARIABLE
		CMPA #0
		BNE SHIFT5
		LDAA #$80
		STAA VARIABLE
SHIFT5:         LDY #VARIABLE
		ASR 0,Y
		LDAA VARIABLE
		STAA $1003
		PULA
		RTS

SUB6:           RTS

SUB7:           RTS

SUB8:           RTS

